C
C  Program : CUTCIF
C            First step in the preparation of the CIFs for the COD
C            Crystallography Open Database : 
C                        http://www.crystallography.net/
C
C   Armel Le Bail (alb@cristal.org) - March 2003
C           updated November 2005
C
C
C  NOTE:
C
C  Before using CUTCIF :
C
C     0 - Ensure that the CIFs do not have data_global at the end
C         of the files... if yes, report that part at the beginning
C     
C     1 - Concatenate a series of selected CIFs (corresponding to
C         some journal issue) under the MS Windows command line 
C         (DOS box), go inside of the appropriate directory, 
C          then use copy:
C          C:\CIF\Iucr\Acta-Cryst-C\2005>copy *.cif 2005-11.cif  
C                        (for instance...) 
C    
C     2 - Edit that multiple CIF
C          
C           -   Remove all spaces (if any) before    
C                          a)             loop_
C                          b)             data_
C                          c)             _
C 
C           -   Remove all useless excessive spaces, keeping only 2
C
C           -   Verify that    data_   is really at the beginning
C                                      of each files
C
C           -   Be careful with multiple CIfs... Ideally, a multiple
C               CIF should have reference details once at the beginning
C               inside of a data_global, then, the individual structures
C               should start by a new data_xxxyyy line followed by a
C               line with _chemical , otherwise, CUTCIF wil not work
C               properly (however, a line with _audit is tolerated,
C               empty lines being removed systematically).
C
C           -   The worst CIFs are made by GSAS (sometimes with _chemical
C               information after the coordinates) and CRYSTAL... The best
C               are maybe made by SHELX, though the H-M space group is
C               sometimes lacking (since Georges has still not implemented
C               automatic space group recognition by the its H-M code...
C
C  Finally using CUTCIF
C
C     4 - Apply then CUTCIF
C
C         If necessary, add some lacking information at the
C            beginning of the files, just after data_ (CUTCIF asks for the
C            number of lines to be added.
C            for instance add tses 2 lines if they are lacking :
C            _journal_name_full  'Acta Crystallographica, Section C'
C            _journal_year       2005
C          
C
C         This is not finished...
C
C         Remaining residues can occur close to the loop_ of the
C         atomic coordinates... remove the isolated ; or text
C         or elsewhere, like this:
C                    _cell_special_details
C                    ; ?
C                    ;
C         or this :
C                    _publ_section_title
C                    ; ?
C                    ;
C                    loop_
C                    _publ_author_name
C                    _publ_author_footnote
C                     ?
C
C                  _journal_data_validation_number  ?
C
C                  loop_
C                    synchrotron 0.850871
C
C                  'RIETAN-2000 (Izumi et al., 2000) developed by F. Izumi'
C                  'VENUS (Izumi & Dilanian, 2002) developed by F. Izumi et al.'
C
C            or footnotes to remove , for instance, change this 
C                  loop_
C                  _publ_author_name
C                  _publ_author_footnote
C                     'M.C. Pujol' .
C                     'X. Mateos' .
C               by :
C                  loop_
C                  _publ_author_name
C                     'M.C. Pujol'
C                     'X. Mateos'
C
C            change this :
C              _chemical_formula_sum  "CaTaAlO5"
C            by this :
C              _chemical_formula_sum  "Ca Ta Al O5"
C            (spaces are necessary there...)
C
C          Remove lines without information like this :
C              _symmetry_space_group_name_Hall  ?
C              _cell_measurement_temperature  ?
C
C          etc, etc, etc, etc
C
C          Remove, remove, remove... (can be done also by a systematic
C          replace by a blank line...).
C
C          If you find this :
C              _symmetry_space_group_name_H-M  ?
C          then add the space group if you can deduce it from
C          some information (the symmetry operators)
C        
C          Add, add, add...
C
C
C     5 - Concatenate for the second time the files made by CUTCIF and
C         correct for the residual errors... The best is to start by
C         the end of the file, checking at the proximity of the loop_
C         lines, checking for the space group description
C            Preferably use this kind of representation with spaces :
C             'P -1'        'P 21/n'      'I 41/a m d'    'R -3 c'
C             'P 63/m c m'  'F d d d'      etc
C         Check if the title is not starting just on the same line
C         as the first ;
C
C         replace this :
C            _publ_section_title
C            ; Search for a transient Superstructure
C            ;
C        by this :
C            _publ_section_title
C            ;
C            Search for a transient Superstructure
C            ;
C        otherwise CIF2COD will not see the title...
C        Same problem elsewhere if the text is placed on the sma line 
C        as the ;
C                
C
C     6 - Reapply CUTCIF to that corrected concatenated big CIF
C
C     7 - Apply now CIF2COD to the new list of cutted individual CIFs
C
C     8 - Edit the .txt file produced by CIF2COD, verify that there is 
C         one line per CIF, and that this line is correctly containing 
C         all the required information
C
C     9 - Process to the addition of the new CIFs into the COD every
C         month. Waiting for that, prepare them inside of a directory
C         named (for instance) new-to-add containing all these new
C         CIFs as well as a global .txt file obtained by adding all
C         the .txt files produced by CIF2COD
C
C
C     With experience you will process >100 CIFs per hour...
C
C
C
      program main
      character*40 fname,fname1,infile
      character*80 text,textl
      character*12 textd
      character*80 tm(500),add(10)
      logical lexist
      write
     1(*,'('' Enter name of multiple CIF (no extension) :'',$)')
      read (*,'(a)')fname1
      if (fname1 .eq. '0') goto 1
      if (fname1 .eq. ' ') goto 1
      write(*,'('' Enter number of first output cif files) :'',$)')
      read (*,'(i)')ncif
      write(*,'('' Enter number of lines to add after data_ :'',$)')
      read (*,'(i)')nadd
       if(nadd.ne.0)then
         do k=1,nadd
          write(*,*)'Enter lines',k
          read (*,'(a)')add(k)
         enddo
       endif
      ichem=0
      idata2=0
      ntm=0
C ---- now open file
      ilen=leng(fname1)
      infile=fname1(1:ilen)//'.cif'
      open (25,file=infile,status='unknown')
C
      jj=ncif-1
C
C Loop on the new output CIF files
C
      read(25,'(a)')text
      if(text.eq.' ')go to 20
1     if(text(1:5).eq.'data_'.and.ichem.eq.0)then
      idata2=0
100   read(25,'(a)')text
      if(text.eq.' ')go to 100
      if(text(1:6).eq.'_audit')go to 100
      if(text(1:9).eq.'_database')go to 100
      if(text(1:10).eq.'_chemical_')idata2=1
        close (26)
        jj=jj+1
        write(fname1,'(i7)')jj
        fname=fname1(1:7)//'.cif'
        open (26,file=fname,status='new')
      textd(1:5)='data_'
      textd(1:12)=textd(1:5)//fname1 
      write(26,'(a)')textd(1:12)
         if(nadd.ne.0)then
         do k=1,nadd
          write(26,'(a)')add(k)
         enddo
         endif
          if(idata2.eq.1)then
          do i=1,ntm
          ilen=leng(tm(i))
          write(26,'(a)')tm(i)(1:ilen)
          enddo
         endif
      ifin=0
      ichem=1
         if(idata2.ne.1)then
          ntm=0
         else
          ichem=0
          ilen=leng(text)
          do k=1,ilen
          if(text(k:k).eq.'?')go to 20
          enddo
          write(26,'(a)')text(1:ilen)
         go to 20
         endif
      endif
C
C
C
      ilen=leng(text)
C
      if(text(1:9).eq.'_chemical')ichem=0
C
C   Arrange Space Group
C
      if(text(1:30).eq.'_symmetry_space_group_name_H-M')then
       do k=31,ilen
       l=k+12
       if(text(k:l).eq.'P2(1)2(1)2(1)')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 21 21 21'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+8
       if(text(k:l).eq.'C 1 2/c 1')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'C 2/c'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+8
       if(text(k:l).eq.'C 1 2/m 1')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'C 2/m'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+8
       if(text(k:l).eq.'C 1 2/m 1')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'C 2/m'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+6
       if(text(k:l).eq.'C 1 2 1')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'C 2'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+8
       if(text(k:l).eq.'P 1 2/m 1')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 2/m'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+7
       if(text(k:l).eq.'P 1 21 1')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 21'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+8
       if(text(k:l).eq.'P 1 2/c 1')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 2/c'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+8
       if(text(k:l).eq.'P 1 2/n 1')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 2/n'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+8
       if(text(k:l).eq.'P 1 2/a 1')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 2/a'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+9
       if(text(k:l).eq.'P 1 21/m 1')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 21/m'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+9
       if(text(k:l).eq.'P 1 21/c 1')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 21/c'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+9
       if(text(k:l).eq.'P 1 21/n 1')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 21/n'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+9
       if(text(k:l).eq.'P 1 21/a 1')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 21/a'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+6
       if(text(k:l).eq.'P2(1)/n')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 21/n'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+4
       if(text(k:l).eq.'P21/n')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 21/n'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+4
       if(text(k:l).eq.'P21/a')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 21/a'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+4
       if(text(k:l).eq.'P21/c')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 21/c'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+6
       if(text(k:l).eq.'P2(1)/c')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 21/c'"
       go to 1
       endif
       enddo
       do k=31,ilen
       l=k+6
       if(text(k:l).eq.'P2(1)/a')then
       write(text,'(a)')"_symmetry_space_group_name_H-M  'P 21/a'"
       go to 1
       endif
       enddo
C
      endif
C
C
C     Check if some angles have a ?, then replace it by 90.
C
      if(text(1:12).eq.'_cell_angle_')then
         do k=1,ilen
             if(text(k:k).eq.'?')then
             go to 25
             endif
         enddo
         go to 26
25    text(k:k+2)='90.'
      ilen=leng(text)
      endif
26    continue
C
C Cases when angles are lacking or even cell parameters !!!
C    to be considered later
C
C
C
C  Check if some lines have only a ?
C                         if yes, remove them...
C
      if(text(1:9).eq.'_chemical')then
         do k=1,ilen
         if(text(k:k).eq.'?')go to 20
         enddo
      endif
      if(text(1:23).eq.'_exptl_crystal_density_')then
         do k=1,ilen
         if(text(k:k).eq.'?')go to 20
         enddo
      endif
      if(text(1:18).eq.'_chemical_melting_')then
         do k=1,ilen
         if(text(k:k).eq.'?')go to 20
         enddo
      endif
C
C Detect 'not measured' or 'SHELX' and eliminate...
C
         do i=5,ilen-11
              k=i+11
              if(text(i:k).eq.'not measured')go to 20
              if(text(i:k).eq.'Not measured')go to 20
              if(text(i:k).eq.'not_measured')go to 20
              if(text(i:k).eq.'Not_measured')go to 20
         enddo
         do i=1,ilen-4
              k=i+4
              if(text(i:k).eq.'SHELX')go to 20
         enddo
         do i=1,ilen-3
              k=i+3
              if(text(i:k).eq.'xtal')go to 20
         enddo
         do i=1,ilen-3
              k=i+3
              if(text(i:k).eq.'Xtal')go to 20
         enddo
         do i=1,ilen-3
              k=i+3
              if(text(i:k).eq.'XTAL')go to 20
         enddo
         do i=1,ilen-5
              k=i+5
              if(text(i:k).eq.'rigaku')go to 20
         enddo
         do i=1,ilen-5
              k=i+5
              if(text(i:k).eq.'Rigaku')go to 20
         enddo
         do i=1,ilen-5
              k=i+5
              if(text(i:k).eq.'TEXSAN')go to 20
         enddo
         do i=1,ilen-5
              k=i+5
              if(text(i:k).eq.'PLATON')go to 20
         enddo
         do i=1,ilen-5
              k=i+5
              if(text(i:k).eq.'PLUTON')go to 20
         enddo
         do i=1,ilen-4
              k=i+4
              if(text(i:k).eq.'ORTEP')go to 20
         enddo
         do i=1,ilen-4
              k=i+4
              if(text(i:k).eq.'SIR92')go to 20
         enddo
         do i=1,ilen-4
              k=i+4
              if(text(i:k).eq.'SIR97')go to 20
         enddo
         do i=1,ilen-7
              k=i+7
              if(text(i:k).eq.'CRYSTALS')go to 20
         enddo
         do i=1,ilen-6
              k=i+6
              if(text(i:k).eq.'MSC/AFC')go to 20
         enddo
         do i=1,ilen-6
              k=i+6
              if(text(i:k).eq.'AFC/MSC')go to 20
         enddo
         do i=1,ilen-5
              k=i+5
              if(text(i:k).eq.'NRCVAX')go to 20
         enddo
         do i=1,ilen-6
              k=i+6
              if(text(i:k).eq.'CAMERON')go to 20
         enddo
         do i=1,ilen-8
              k=i+8
              if(text(i:k).eq.'flotation')go to 20
         enddo
         do i=1,ilen-12
              k=i+12
              if(text(i:k).eq.'empirical via')go to 20
         enddo
         do i=1,ilen-12
              k=i+12
              if(text(i:k).eq.'international')go to 20
         enddo
         do i=1,ilen-12
              k=i+12
              if(text(i:k).eq.'International')go to 20
         enddo
         do i=1,ilen-13
              k=i+13
              if(text(i:k).eq.'not determined')go to 20
         enddo
         do i=1,ilen-13
              k=i+13
              if(text(i:k).eq.'Not determined')go to 20
         enddo
         do i=1,ilen-13
              k=i+13
              if(text(i:k).eq.'H atoms riding')go to 20
         enddo
C
C  Eliminate some parts with 
C  _etc
C  ;
C  etc
C  ;
C
C  this one with ? only...
C
C
      if(text(1:25).eq.'_chemical_name_systematic')then
         ii=0
4        read(25,'(a)')text
          if(text.eq.' ')go to 4
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
               ilen=leng(text)
               do k=1,ilen
               if(text(k:k).eq.'?')go to 4
               enddo
           endif
         if(ii.eq.2) go to 20
         go to 4
        endif
C
C these ones systematically excluded
C
      if(text(1:22).eq.'_publ_section_abstract')then
         ii=0
5        read(25,'(a)')text
          if(text.eq.' ')go to 5
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 5
        endif
      if(text(1:21).eq.'_publ_section_comment')then
         ii=0
6        read(25,'(a)')text
          if(text.eq.' ')go to 6
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 6
        endif
      if(text(1:30).eq.'_publ_section_acknowledgements')then
         ii=0
7        read(25,'(a)')text
          if(text.eq.' ')go to 7
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 7
        endif
      if(text(1:24).eq.'_publ_section_references')then
         ii=0
8        read(25,'(a)')text
          if(text.eq.' ')go to 8
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 8
        endif
      if(text(1:29).eq.'_publ_section_figure_captions')then
         ii=0
9        read(25,'(a)')text
          if(text.eq.' ')go to 9
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 9
        endif
      if(text(1:24).eq.'_publ_section_exptl_prep')then
         ii=0
10       read(25,'(a)')text
          if(text.eq.' ')go to 10
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 10
        endif
      if(text(1:30).eq.'_publ_section_exptl_refinement')then
         ii=0
11       read(25,'(a)')text
          if(text.eq.' ')go to 11
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 11
        endif
      if(text(1:28).eq.'_publ_section_title_footnote')then
         ii=0
12       read(25,'(a)')text
          if(text.eq.' ')go to 12
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 12
        endif
      if(text(1:26).eq.'_exptl_crystal_preparation')then
         ii=0
13       read(25,'(a)')text
          if(text.eq.' ')go to 13
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 13
        endif
      if(text(1:14).eq.'_publ_contact_')then
         ii=0
14       read(25,'(a)')text
          if(text.eq.' ')go to 14
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 14
        endif
      if(text(1:26).eq.'_publ_section_experimental')then
         ii=0
15       read(25,'(a)')text
          if(text.eq.' ')go to 15
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 15
        endif
      if(text(1:23).eq.'_diffrn_special_details')then
         ii=0
16       read(25,'(a)')text
          if(text.eq.' ')go to 16
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 16
        endif
      if(text(1:21).eq.'_geom_special_details')then
         ii=0
17       read(25,'(a)')text
          if(text.eq.' ')go to 17
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 17
        endif
       if(text(1:23).eq.'_refine_special_details')then
         ii=0
18       read(25,'(a)')text
          if(text.eq.' ')go to 18
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 18
        endif
       if(text(1:22).eq.'_exptl_special_details')then
         ii=0
19       read(25,'(a)')text
          if(text.eq.' ')go to 19
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 19
        endif
       if(text(1:28).eq.'_refine_ls_extinction_method')then
         ii=0
31       read(25,'(a)')text
          if(text.eq.' ')go to 31
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 31
        endif
       if(text(1:26).eq.'_computing_data_collection')then
         ii=0
32       read(25,'(a)')text
          if(text.eq.' ')go to 32
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 32
        endif
       if(text(1:27).eq.'_refine_ls_weighting_scheme')then
         ii=0
33       read(25,'(a)')text
          if(text.eq.' ')go to 33
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 33
        endif
       if(text(1:29).eq.'_refine_ls_hydrogen_treatment')then
         ii=0
34       read(25,'(a)')text
          if(text.eq.' ')go to 34
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 34
        endif
       if(text(1:29).eq.'_exptl_crystal_')then
         ii=0
35       read(25,'(a)')text
          if(text.eq.' ')go to 35
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 35
        endif
       if(text(1:31).eq.'_computing_structure_refinement')then
         ii=0
36       read(25,'(a)')text
          if(text.eq.' ')go to 36
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 36
        endif
       if(text(1:22).eq.'_publ_section_synopsis')then
         ii=0
37       read(25,'(a)')text
          if(text.eq.' ')go to 37
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 37
        endif
       if(text(1:26).eq.'_refine_ls_extinction_coef')then
         ii=0
38       read(25,'(a)')text
          if(text.eq.' ')go to 38
           if(text(1:1).eq.';')then
             ii=ii+1
             else
             if(ii.eq.0)go to 1
           endif
         if(ii.eq.2) go to 20
         go to 38
        endif
C
C  Eliminates:
C
      if(text(1:1).eq.'#')go to 20
      if(text(1:5).eq.'data_')go to 20
      if(text(1:7).eq.'_audit_')go to 20
      if(text(1:15).eq.'_database_code_')go to 20
      if(text(1:22).eq.'_journal_coeditor_code')go to 20
      if(text(1:14).eq.'_journal_coden')go to 20
      if(text(1:13).eq.'_journal_date')go to 20
      if(text(1:14).eq.'_journal_issue')go to 20
      if(text(1:14).eq.'_journal_paper')go to 20
      if(text(1:10).eq.'_computing')go to 20
C
C
      if(text(1:15).eq.'_diffrn_source')go to 20
      if(text(1:17).eq.'_diffrn_radiation')go to 20
      if(text(1:29).eq.'_cell_measurement_reflns_used')go to 20
      if(text(1:27).eq.'_cell_measurement_theta_min')go to 20
      if(text(1:27).eq.'_cell_measurement_theta_max')go to 20
      if(text(1:29).eq.'_exptl_absorpt_coefficient_mu')go to 20
      if(text(1:26).eq.'_exptl_crystal_description')go to 20
      if(text(1:20).eq.'_exptl_crystal_size_')go to 20
      if(text(1:21).eq.'_exptl_crystal_colour')go to 20
      if(text(1:29).eq.'_exptl_crystal_density_method')go to 20
      if(text(1:26).eq.'_diffrn_measurement_device')go to 20
      if(text(1:26).eq.'_diffrn_measurement_method')go to 20
      if(text(1:15).eq.'_diffrn_reflns_')go to 20
      if(text(1:20).eq.'_reflns_number_total')go to 20
      if(text(1:23).eq.'_reflns_number_observed')go to 20
      if(text(1:26).eq.'_reflns_observed_criterion')go to 20
      if(text(1:17).eq.'_diffrn_standards')go to 20
      if(text(1:32).eq.'_refine_ls_structure_factor_coef')go to 20
      if(text(1:30).eq.'_refine_ls_goodness_of_fit_obs')go to 20
      if(text(1:24).eq.'_refine_ls_number_reflns')go to 20
      if(text(1:28).eq.'_refine_ls_number_parameters')go to 20
      if(text(1:29).eq.'_refine_ls_hydrogen_treatment')go to 20
      if(text(1:24).eq.'_refine_ls_shift/esd_max')go to 20
      if(text(1:24).eq.'_refine_diff_density_max')go to 20
      if(text(1:24).eq.'_refine_diff_density_min')go to 20
      if(text(1:26).eq.'_refine_ls_extinction_coef')go to 20
      if(text(1:24).eq.'_refine_ls_wR_factor_all')go to 20
      if(text(1:30).eq.'_refine_ls_goodness_of_fit_all')go to 20
      if(text(1:22).eq.'_refine_ls_R_factor_gt')go to 20
      if(text(1:22).eq.'_refine_ls_matrix_type')go to 20
      if(text(1:23).eq.'_refine_ls_wR_factor_gt')go to 20
      if(text(1:23).eq.'_refine_ls_shift/su_max')go to 20
      if(text(1:25).eq.'_refine_ls_shift/esd_mean')go to 20
      if(text(1:23).eq.'_refine_ls_R_factor_all')go to 20
      if(text(1:24).eq.'_refine_ls_shift/su_mean')go to 20
      if(text(1:32).eq.'_refine_ls_abs_structure_details')go to 20	
      if(text(1:32).eq.'_refine_ls_extinction_expression')go to 20	
      if(text(1:24).eq.'_refine_ls_wR_factor_ref')go to 20
      if(text(1:27).eq.'_refine_ls_restrained_S_all')go to 20
      if(text(1:28).eq.'_refine_ls_number_restraints')go to 20
      if(text(1:28).eq.'_refine_ls_weighting_details')go to 20
      if(text(1:30).eq.'_refine_ls_goodness_of_fit_ref')go to 20
      if(text(1:21).eq.'_refine_ls_restrained')go to 20
      if(text(1:29).eq.'_refine_ls_number_constraints')go to 20
      if(text(1:23).eq.'_exptl_crystal_size_min')go to 20
      if(text(1:25).eq.'_chemical_compound_source')go to 20
      if(text(1:17).eq.'_reflns_number_gt')go to 20
      if(text(1:20).eq.'_exptl_crystal_F_000')go to 20
      if(text(1:28).eq.'_reflns_threshold_expression')go to 20
      if(text(1:21).eq.'_atom_sites_solution_')go to 20
      if(text(1:32).eq.'_diffrn_detector_area_resol_mean')go to 20
      if(text(2:7).eq.'calc w')go to 20	
      if(text(3:8).eq.'calc w')go to 20	
      if(text(4:9).eq.'calc w')go to 20	
      if(text(5:10).eq.'calc w')go to 20	
      if(text(6:11).eq.'calc w')go to 20	
      if(text(7:12).eq.'calc w')go to 20	
      if(text(8:13).eq.'calc w')go to 20	
      if(text(9:14).eq.'calc w')go to 20	
      if(text(10:15).eq.'calc w')go to 20	
      if(text(11:16).eq.'calc w')go to 20	
      if(text(12:17).eq.'calc w')go to 20	
      if(text(2:6).eq.'Flack')go to 20	
      if(text(3:7).eq.'Flack')go to 20	
      if(text(4:8).eq.'Flack')go to 20	
      if(text(5:9).eq.'Flack')go to 20	
      if(text(6:10).eq.'Flack')go to 20	
      if(text(7:11).eq.'Flack')go to 20	
      if(text(3:7).eq.'Fc^*^')go to 20	
      if(text(3:7).eq.'Fc^*^')go to 20	
      if(text(4:8).eq.'Fc^*^')go to 20	
      if(text(5:9).eq.'Fc^*^')go to 20	
      if(text(6:10).eq.'Fc^*^')go to 20	
      if(text(7:11).eq.'Fc^*^')go to 20	
      if(text(1:30).eq.'_refine_ls_abs_structure_Flack')go to 20
      if(text(1:25).eq.'_diffrn_measured_fraction')go to 20	
      if(text(1:15).eq.'_exptl_absorpt_')go to 20	
      if(text(1:16).eq.'_publ_requested_')go to 20	
      if(text(1:27).eq.'_diffrn_measurement_details')go to 20	
      if(text(1:16).eq.'_diffrn_detector')go to 20	
      if(text(1:11).eq.'_atom_type_')go to 20	
      if(text(1:3).eq.'END')go to 20
C
C
      if(text(1:18).eq.'_atom_site_fract_x')ifin=1
C
C  Check for loops on anisotropic thermal motion
C                     bond distances
C                     angles
C                     torsion angles
      if(text(1:5).eq.'loop_'.and.ifin.eq.3)ifin=1
      if(text(1:5).eq.'loop_'.and.ifin.eq.1)then
110   read(25,'(a)')text
      if(text.eq.' ')go to 110
        if(text(1:11).eq.'_geom_bond_')then
           write(26,'(a)')'loop_'
           ilen=leng(text)
           write(26,'(a)')text(1:ilen)
           ifin=1
           go to 20
        endif
        if(text(1:17).eq.'_atom_site_aniso_')then
           write(26,'(a)')'loop_'
           ilen=leng(text)
           write(26,'(a)')text(1:ilen)
           textl=text
           ifin=1
           go to 20
        endif
        ifin=3
        go to 20
      endif
      if(ifin.eq.3)go to 20
C
C  Check for loop on _atom_type
C                 and on _diffrn_standard
C
      itype=0
      if(text(1:5).eq.'loop_')then
      ii=0
120   read(25,'(a)')text
      ilen=leng(text)
      ii=ii+1
      if(text.eq.' ')go to 120
        if(text(1:10).eq.'_atom_type')then
          itype=1
        go to 120
        else
            if(text(1:16).eq.'_diffrn_standard')then
            itype=1
            go to 120
            endif
           if(text(1:1).eq.'_')then
           if(itype.eq.1)go to 1
           write(26,'(a)')'loop_'
           textl='loop_'
           go to 1
          endif
        go to 120
        endif
	endif
      if(text(1:16).eq.'_diffrn_standard')go to 20
C
C  Check for author address...remove them
C
      if(text(1:20).eq.'_publ_author_name')then
                 ntm=ntm+1
                 write(tm(ntm),'(a)')'loop_'
      endif
      if(text(1:20).eq.'_publ_author_address')then
         ii=0
150      read(25,'(a)')text
          if(text.eq.' ')go to 150
         ilen=leng(text)
         if(text(1:12).eq.'_publ_author')go to 150
         if(text(1:1).eq.'_')go to 1
          if(text(1:5).eq.'data_')go to 1
           if(text(1:1).eq.';')then
             ii=ii+1
             else
              if(ii.eq.0)then
                     write(26,'(a)')text(1:ilen)
                     if(ichem.eq.0)go to 200
                     ntm=ntm+1
                     if(ntm.gt.500)then
                     write(*,*)'ntm > 500...'
                     STOP
                     endif
                     write(tm(ntm),'(a)')text(1:ilen)
200                  continue
              endif
           endif
                 if(ii.eq.2) then
                  ii=0
                  go to 150
                 endif
         go to 150
        endif
C
C  Verify the presence of the coordinates loop_ line
C
      if(text(1:16).eq.'_atom_site_label')then
        if(textl(1:5).ne.'loop_')write(26,'(a)')'loop_'
      endif
C
C Write the line...
C
      ilen=leng(text)
      write(26,'(a)')text(1:ilen)
      textl=text
C
C Save all before _chemical
C
      if(ichem.eq.0)go to 20
      ntm=ntm+1
      if(ntm.gt.500)then
        write(*,*)'ntm > 500...'
        STOP
      endif
      write(tm(ntm),'(a)')text(1:ilen)
20    continue
      read(25,'(a)',err=30)text
      if(text.eq.' ')go to 20
      go to 1
C
C End of loop
C
30    close (26)
      close (25)
C
      stop
      end
C
C----------------------------------------------------------------------
C
      integer function leng(string)
C     returns significant length of  'string'
      character*(*)string
      do 1 leng=len(string),0,-1
1        if (string(leng:leng) .ne. ' ') goto 2
2     end
C
C----------------------------------------------------------------------C
C
